searchNodes=[{"doc":"SchedEx schedules jobs (either an m,f,a or a function) to run in the future. These jobs are run in isolated processes, and are unsurpervised.","ref":"SchedEx.html","title":"SchedEx","type":"module"},{"doc":"Cancels the given scheduled job","ref":"SchedEx.html#cancel/1","title":"SchedEx.cancel/1","type":"function"},{"doc":"Runs the given function at the given time","ref":"SchedEx.html#run_at/2","title":"SchedEx.run_at/2","type":"function"},{"doc":"Runs the given module, function and argument at the given time","ref":"SchedEx.html#run_at/4","title":"SchedEx.run_at/4","type":"function"},{"doc":"Runs the given function on every occurrence of the given crontab. If func is of arity 1, the scheduled execution time will be passed for each invocation Takes the same options as run_every/5","ref":"SchedEx.html#run_every/3","title":"SchedEx.run_every/3","type":"function"},{"doc":"Runs the given module, function and argument on every occurrence of the given crontab. Any values in the arguments array which are equal to the magic symbol :sched_ex_scheduled_time are replaced with the scheduled execution time for each invocation Supports the following options: timezone : A string timezone identifier ( America/Chicago ) specifying the timezone within which the crontab should be interpreted. If not specified, defaults to UTC time_scale : A module that implements the SchedEx.TimeScale behaviour, by default is set to SchedEx.IdentityTimeScale . Can be used to speed up time (often used for speeding up test runs) name : To attach a name to the process. Useful for adding a name to Registry to lookup later. ie. {:via, Registry, {YourRegistryName, &quot;scheduled-task-1&quot;}} nonexistent_time_strategy : How to handle scheduled runs within a DST forward boundary when evaluated within the timezone specified by the timezone option. Valid values are :skip (the default) and :adjust . By way of example, for a job which is scheduled to happen daily at 2:30am in the America/Chicago timezone, on days where a forward DST transition happens (such as 10 March 2019) :skip will skip this invocation and next run the job at 2:30 CDT 11 March 2019, while :adjust will run the job the same amount of time into the day as it would normally run (2.5 hours after midnight, which will be at 3:30 CDT 10 March 2019).","ref":"SchedEx.html#run_every/5","title":"SchedEx.run_every/5","type":"function"},{"doc":"Runs the given function in given number of units (this corresponds to milliseconds unless a custom time_scale is specified). If func is of arity 1, the scheduled execution time will be passed for each invocation Takes the same options as run_in/5","ref":"SchedEx.html#run_in/3","title":"SchedEx.run_in/3","type":"function"},{"doc":"Runs the given module, function and argument in given number of units (this corresponds to milliseconds unless a custom time_scale is specified). Any values in the arguments array which are equal to the magic symbol :sched_ex_scheduled_time are replaced with the scheduled execution time for each invocation Supports the following options: repeat : Whether or not this job should be recurring start_time : A DateTime to use as the basis to offset from time_scale : A module that implements the SchedEx.TimeScale behaviour, by default is set to SchedEx.IdentityTimeScale . Can be used to speed up time (often used for speeding up test runs) name : To attach a name to the process. Useful for adding a name to Registry to lookup later. ie. {:via, Registry, {YourRegistryName, &quot;scheduled-task-1&quot;}}","ref":"SchedEx.html#run_in/5","title":"SchedEx.run_in/5","type":"function"},{"doc":"Returns stats on the given job. Stats are returned for: scheduling_delay : The delay between when the job was scheduled to execute, and the time it actually was executed. Based on the quantized scheduled start, and so does not include quantization error. Value specified in microseconds. quantization_error : Erlang is only capable of scheduling future calls with millisecond precision, so there is some inevitable precision lost between when the job would be scheduled in a perfect world, and how well Erlang is able to schedule the job (ie: to the closest millisecond). This error value captures that difference. Value specified in microseconds. execution_time : The amount of time the job spent executing. Value specified in microseconds.","ref":"SchedEx.html#stats/1","title":"SchedEx.stats/1","type":"function"},{"doc":"The default module used to set the time_scale . Can be thought of as &quot;normal time&quot; where &quot;now&quot; is now and speedup is 1 (no speedup).","ref":"SchedEx.IdentityTimeScale.html","title":"SchedEx.IdentityTimeScale","type":"module"},{"doc":"Constrols time in SchedEx, often used to speed up test runs, or implement custom timing loops. Default implementation is SchedEx.IdentityTimeScale .","ref":"SchedEx.TimeScale.html","title":"SchedEx.TimeScale","type":"behaviour"},{"doc":"Must return the current time in the specified timezone.","ref":"SchedEx.TimeScale.html#c:now/1","title":"SchedEx.TimeScale.now/1","type":"callback"},{"doc":"Must returns a float factor to speed up delays by.","ref":"SchedEx.TimeScale.html#c:speedup/0","title":"SchedEx.TimeScale.speedup/0","type":"callback"},{"doc":"Copyright (c) 2018 Mat Trudel on behalf of FunnelCloud Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"SchedEx is a simple yet deceptively powerful scheduling library for Elixir. Though it is almost trivially simple by design, it enables a number of very powerful use cases to be accomplished with very little effort. SchedEx is written by Mat Trudel , and development is generously supported by the fine folks at FunnelCloud . For usage details, please refer to the documentation .","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"In most contexts SchedEx.run_every is the function most commonly used. There are two typical use cases: Static Configuration This approach is useful when you want SchedEx to manage jobs whose configuration is static. At FunnelCloud, we use this approach to run things like our hourly reports, cleanup tasks and such. Typically, you will start jobs inside your application.ex file: defmodule Example.Application do use Application def start ( _type , _args ) do children = [ # Call Runner.do_frequent/0 every five minutes %{ id : &quot;frequent&quot; , start : { SchedEx , :run_every , [ Example.Runner , :do_frequent , [ ] , &quot;*/5 * * * *&quot; ] } } , # Call Runner.do_daily/0 at 1:01 UTC every day %{ id : &quot;daily&quot; , start : { SchedEx , :run_every , [ Example.Runner , :do_daily , [ ] , &quot;1 1 * * *&quot; ] } } , # You can also pass a function instead of an m,f,a: %{ id : &quot;hourly&quot; , start : { SchedEx , :run_every , [ fn -&gt; IO . puts &quot;It is the top of the hour&quot; end , &quot;0 * * * *&quot; ] } } ] opts = [ strategy : :one_for_one , name : Example.Supervisor ] Supervisor . start_link ( children , opts ) end end This will cause the corresponding methods to be run according to the specified crontab entries. If the jobs crash they also take down the SchedEx process which ran them (SchedEx does not provide supervision by design). Your application's Supervisor will then restart the relevant SchedEx process, which will continue to run according to its crontab entry. Dynamically Scheduled Tasks SchedEx is especially suited to running tasks which run on a schedule and may be dynamically configured by the user. For example, at FunnelCloud we have a ScheduledTask Ecto schema with a string field called crontab . At startup our scheduled_task application reads entries from this table, determines the module, function, argument which should be invoked when the task comes due, and adds a SchedEx job to a supervisor: def start_scheduled_tasks ( sup , scheduled_tasks ) do scheduled_tasks |&gt; Enum . map ( &amp; child_spec_for_scheduled_task / 1 ) |&gt; Enum . map ( &amp; ( DynamicSupervisor . start_child ( sup , &amp;1 ) ) ) end defp child_spec_for_scheduled_task ( % ScheduledTask { id : id , crontab : crontab } = task ) do %{ id : &quot;scheduled-task- \#{ id } &quot; , start : { SchedEx , :run_every , mfa_for_task ( task ) ++ [ crontab ] } } end defp mfa_for_task ( task ) do # Logic that returns the [m, f, a] that should be invoked when task comes due [ IO , :puts , [ &quot;Hello, scheduled task: \#{ inspect task } &quot; ] ] end This will start one SchedEx process per ScheduledTask , all supervised within a DynamicSupervisor . If either SchedEx or the invoked function crashes DynamicSupervisor will restart it, making this approach robust to failures anywhere in the application. Note that the above is somewhat simplified - in production we have some additional logic to handle starting / stopping / reloading tasks on user change. You can optionally pass a name to the task that would allow you to lookup the task later with Registry or gproc and remove it like so: child_spec = %{ id : &quot;scheduled-task- \#{ id } &quot; , start : { SchedEx , :run_every , mfa_for_task ( task ) ++ [ crontab , [ name : { :via , Registry , { RegistryName , &quot;scheduled-task- \#{ id } &quot; } } ] ] } } def get_scheduled_item ( id ) do #ie. &quot;scheduled-task-1&quot; list = Registry . lookup ( RegistryName , id ) if length ( list ) &gt; 0 do { pid , _ } = hd ( list ) { :ok , pid } else { :error , &quot;does not exist&quot; } end end def cancel_scheduled_item ( id ) do with { :ok , pid } &lt;- get_scheduled_item ( id ) do DynamicSupervisor . terminate_child ( DSName , pid ) end end Then in your children in application.ex { Registry , keys : :unique , name : RegistryName } , { DynamicSupervisor , strategy : :one_for_one , name : DSName } ,","ref":"readme.html#basic-usage","title":"Overview - Basic Usage","type":"extras"},{"doc":"In addition to SchedEx.run_every , SchedEx provides two other methods which serve to schedule jobs; SchedEx.run_at , and SchedEx.run_in . As the names suggest, SchedEx.run_at takes a DateTime struct which indicates the time at which the job should be executed, and SchedEx.run_in takes a duration in integer milliseconds from the time the function is called at which to execute the job. Similarly to SchedEx.run_every , these functions both come in module, function, argument and fn form. The above functions have the same return values as standard start_link functions ( {:ok, pid} on success, {:error, error} on error). The returned pid can be passed to SchedEx.cancel to cancel any further invocations of the job.","ref":"readme.html#other-functions","title":"Overview - Other Functions","type":"extras"},{"doc":"SchedEx uses the crontab library to parse crontab strings. If it is unable to parse the given crontab string, an error is returned from the SchedEx.run_every call and no jobs are scheduled. Building on the support provided by the crontab library, SchedEx supports extended crontabs. Such crontabs have 7 segments instead of the usual 5; one is added to the beginning of the crontab and expresses a seconds value, and one added to the end expresses a year value. As such, it's possible to specify a unique instant down to the second, for example: 50 59 23 31 12 * 1999 # You&#39;d better be getting ready to party Jobs scheduled via SchedEx.run_every are implicitly recurring; they continue to to execute according to the crontab until SchedEx.cancel/1 is called or the original calling process terminates. If job execution takes longer than the scheduling interval, the job is requeued at the next matching interval (for example, if a job set to run every minute (crontab * * * * * ) takes 61 seconds to run at minute x it will not run at minute x+1 and will next run at minute x+2 ).","ref":"readme.html#crontab-details","title":"Overview - Crontab details","type":"extras"},{"doc":"SchedEx has a feature called TimeScales which help provide a performant and high parity environment for testing scheduled code. When invoking SchedEx.run_every or SchedEx.run_in , you can pass an optional time_scale parameter which allows you to change the speed at which time runs within SchedEx. This allows you to run an entire day (or longer) worth of scheduling time in a much shorter amount of real time. For example: defmodule ExampleTest do use ExUnit.Case defmodule AgentHelper do def set ( agent , value ) do Agent . update ( agent , fn _ -&gt; value end ) end def get ( agent ) do Agent . get ( agent , &amp; &amp;1 ) end end defmodule TestTimeScale do def now ( _ ) do DateTime . utc_now ( ) end def speedup do 86400 end end test &quot;updates the agent at 10am every morning&quot; do { :ok , agent } = start_supervised ( { Agent , fn -&gt; nil end } ) SchedEx . run_every ( AgentHelper , :set , [ agent , :sched_ex_scheduled_time ] , &quot;* 10 * * *&quot; , time_scale : TestTimeScale ) # Let SchedEx run through a day&#39;s worth of scheduling time Process . sleep ( 1000 ) expected_time = Timex . now ( ) |&gt; Timex . beginning_of_day ( ) |&gt; Timex . shift ( hours : 34 ) assert DateTime . diff ( AgentHelper . get ( agent ) , expected_time ) == 0 end end will run through an entire day's worth of scheduling time in one second, and allows us to test against the expectations of the called function quickly, while maintaining near-perfect parity with development. The only thing that changes in the test environment is the passing of a time_scale ; all other code is exactly as it is in production. Note that in the above test, the atom :sched_ex_scheduled_time is passed as a value in the argument array. This atom is treated specially by SchedEx, and is replaced by the scheduled invocation time for which the function is being called.","ref":"readme.html#testing","title":"Overview - Testing","type":"extras"},{"doc":"SchedEx can be installed by adding :sched_ex to your list of dependencies in mix.exs : def deps do [ { :sched_ex , &quot;~&gt; 1.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Copyright (c) 2018 Mat Trudel on behalf of FunnelCloud Inc. This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]